using System;
using PkmnLibSharp.Utilities;

namespace PkmnLibSharp.Battling.Events
{
    public class WeatherChangeEvent : EventData
    {
        internal WeatherChangeEvent(EventDataKind kind, IntPtr ptr) : base(kind, ptr)
        {
        }

        public string? WeatherName => Pkmnlib.Generated.WeatherChangeEvent.GetWeatherName(Ptr).PtrString();

        protected override void DeletePtr()
        {
            Pkmnlib.Generated.WeatherChangeEvent.Destruct(Ptr);
        }
    }
}