using System;
using PkmnLibSharp.Library.Evolution;
using PkmnLibSharp.Utilities;

namespace PkmnLibSharp.Battling
{
    public class EvolutionScript : PointerWrapper
    {
        internal EvolutionScript(IntPtr script) : base(script)
        {
        }

        public bool DoesEvolveFromLevelUp(EvolutionData data, Pokemon pokemon)
        {
            unsafe
            {
                byte b = 0;
                var bPtr = new IntPtr(&b);
                Pkmnlib.Generated.EvolutionScript.DoesEvolveFromLevelUp(Ptr, data.Ptr, pokemon.Ptr, bPtr).Assert();
                return b == 1;
            }
        }
        
        
        protected override void DeletePtr()
        {
            throw new System.NotImplementedException();
        }
    }
}